#!/bin/sh

VERSION_TAIL_FILE=/mnt/mtd/td-9632ae2-onvif-tail
SOFTPACK_FILE_NAME=/mnt/00/updatepack.tar
UPDATE_EXE_FILE=/mnt/mtd/nfsdir/bin/update_exe
CHECK_FILE_EXE=/mnt/mtd/checkver
PRE_UPDATE_EXE_FILE=/mnt/mtd/nfsdir/bin/pre_update_exe
SOFT_FULL_FILE=/mnt/mtd/nfsdir/bin/SoftFull

if ! [ -d /tmp_run ];
then
    mkdir /tmp_run
fi
mount -t ramfs none /tmp_run

if [ -f /mnt/mtd/nfsdir/bin/SoftList ] && [ -f /mnt/mtd/nfsdir/bin/init.sh ] && [ -f $SOFT_FULL_FILE ];
then
	cd /mnt/mtd/nfsdir/bin
#	/mnt/mtd/nfsdir/bin/ipcamera check ../bin ./SoftList
	if [ $? -eq 0 ];
	then
		./init.sh
		exit 0
	fi
fi

echo start update ............

rm /mnt/mtd/nfsdir/bin -rf

echo install sdcard driver .............

#insmod /mnt/mtd/ftsdc010.ko
if ! [ -d /mnt/00 ]
then
	mkdir /mnt/00
fi

#Ҫ3515SDĽڵһ
mount -t vfat /dev/mmcblk0p1 /mnt/00
if [ $? -eq 0 ];
then
	echo mount sdcard success ................................
else
	echo mount sdcard fail .........
fi

if [ -f $SOFTPACK_FILE_NAME ]
then
	echo find software \"updatepack.tar\"...........................
	$CHECK_FILE_EXE $SOFTPACK_FILE_NAME $VERSION_TAIL_FILE
	if [ $? -eq 0 ]
	then
		tar xvf $SOFTPACK_FILE_NAME -C /mnt/mtd/nfsdir bin/pre_update_exe
		if [ -f $PRE_UPDATE_EXE_FILE ]
		then
			chmod 777 $PRE_UPDATE_EXE_FILE
			$PRE_UPDATE_EXE_FILE
		fi

		tar xvf $SOFTPACK_FILE_NAME -C /mnt/mtd/nfsdir
		if [ $? -eq 0 ]
		then
			if [ -f $UPDATE_EXE_FILE ]
			then
				chmod 777 $UPDATE_EXE_FILE
				$UPDATE_EXE_FILE
			fi
			echo success > $SOFT_FULL_FILE
			cd /mnt/mtd/nfsdir/bin
			reboot
			exit 0
		fi
	fi
fi

echo start update from ftp : 192.168.0.200 .......

ifconfig eth0 192.168.0.2
tftp -g -l /tmp_run/update.tar.gz -r updatepack.tar 192.168.0.200
if [ $? -ne 0 ]
then
	echo can\'t connect ftp : 192.168.0.200 .......
	exit 1
fi

echo get software \"updatepack.tar\" success from ftp : 192.168.0.200 .......
$CHECK_FILE_EXE /tmp_run/update.tar.gz $VERSION_TAIL_FILE
if [ $? -eq 0 ]
then
	tar xvf /tmp_run/update.tar.gz -C /mnt/mtd/nfsdir bin/pre_update_exe
	if [ -f $PRE_UPDATE_EXE_FILE ]
	then
		chmod 777 $PRE_UPDATE_EXE_FILE
		$PRE_UPDATE_EXE_FILE
	fi

	tar xvf /tmp_run/update.tar.gz -C /mnt/mtd/nfsdir/
	if [ -f $UPDATE_EXE_FILE ]
	then
		chmod 777 $UPDATE_EXE_FILE
		$UPDATE_EXE_FILE
	fi

	echo success > $SOFT_FULL_FILE
	cd /mnt/mtd/nfsdir/bin
	reboot
	exit 0
else
	exit 1
fi
